#include <hmg.ch>

* 20/4/16
*
* Modified function Load_Grid_PRV() and added Sort_Grid_PRV(). 
* Added column head click, record lock when updating or deleting record in DBF, and minor improvements ...

	FIELD LNDID, PRVID, PRVNM
	MEMV lNew
	MEMV aImages
	MEMV aRC

	MEMV nVertMargin
	MEMV nHorzMargin
	
	MEMV nFontSize
	MEMV cFontName
	MEMV nCharLength
	MEMV nLineHeigth
	
	MEMV nMostRightCol
	MEMV nPageHeigth
	MEMV nLinesPerPag
	MEMV nLinesPrinted 
	MEMV nPageNr
		
	MEMV nPrintRow 
	MEMV nPrintCol 
*------------------------------------------------------------------------------*
PROCEDURE Main()
*------------------------------------------------------------------------------*
	PRIV lNew := .F.
	PRIV aImages := {1,1,1}

	#DEFINE LNDID 1
	#DEFINE PRVID 2
	#DEFINE PRVNM 3
	#DEFINE nAantCol 3
	
	set(_SET_DELETED,.T.) 
	set(_SET_SOFTSEEK,.F.) 
	set date format 'dd/mm/yyyy'  
	set exclusive off	

	USE PRV ALIAS PRV NEW 
	INDEX ON LndID + PrvID TO PRVL01
	INDEX ON LndID + PrvNm TO PRVL02
	SET INDEX TO PRVL01, PRVL02
	
	IF ! IsWindowDefined( Win_PRV )
		Load Window Win_PRV
		Win_PRV.Center 
		Win_PRV.Activate
	ENDIF
RETURN

*------------------------------------------------------------------------------*
PROCEDURE OnInit_Win_PRV()
*------------------------------------------------------------------------------*
	ON KEY ESCAPE OF Win_PRV ACTION ThisWindow.Release

	Load_Grid_PRV(0,1)
	Win_PRV.Grid_PRV.Refresh
	Win_PRV.Grid_PRV.Setfocus
RETURN

*------------------------------------------------------------------------------*
PROCEDURE Load_Grid_PRV(nRecno, nCol, lSetValue)
*------------------------------------------------------------------------------*
	LOCAL nRow := 0
	LOCAL i

	DEFAULT lSetValue := .t.

	PRV->(DBSetorder('PRVL01'))
	PRV->(DBGotop())
	Win_PRV.Grid_PRV.DeleteAllItems
	DO WHILE .NOT. PRV->(EOF())
		Win_PRV.Grid_PRV.AddItem( {PRV->LndID, PRV->PrvID, PRV->PrvNm} )
		IF PRV->(recno()) == nRecno	
			nRow := Win_PRV.Grid_PRV.ItemCount
		ENDIF
		PRV->(DBSkip())
	ENDDO
	IF nRow == 0
		nRow := 1
	ENDIF
	FOR i := 1 TO nAantCol
		Win_PRV.Grid_PRV.HeaderImage(i) := 1
	NEXT i
	IF lSetValue
		Win_PRV.Grid_PRV.Value := {nRow,nCol}
	ENDIF
RETURN

*------------------------------------------------------------------------------*
PROCEDURE Sort_Grid_PRV(nCol)
*------------------------------------------------------------------------------*
	LOCAL i, j, aItem
	LOCAL lAscend := ( aImages[ nCol ] == 1 )
	LOCAL aGrid := ARRAY( Win_PRV.Grid_PRV.ItemCount, nAantCol )
			 
	FOR i := 1 To Win_PRV.Grid_PRV.ItemCount
		aItem := Win_PRV.Grid_PRV.Item(i)  
		FOR j := 1 TO nAantCol
			aGrid[i,j] := aItem[j] 
		NEXT j
	NEXT i

	lAscend := !lAscend

	aImages[ nCol ] := iif( lAscend, 1, 2 )

	IF lAscend
		ASORT(aGrid ,,, { |x,y| x[nCol] < y[nCol] } ) 
	ELSE
		ASORT(aGrid ,,, { |x,y| x[nCol] > y[nCol] } )
	ENDIF
		 
	Win_PRV.Grid_PRV.HeaderImage( nCol ) := aImages[ nCol ]

	//Win_PRV.Grid_PRV.DeleteAllItems
	//AEVAL( aGrid, { |aGrid| Win_PRV.Grid_PRV.AddItem( aGrid ) } )
	Win_PRV.Grid_PRV.SetArray( aGrid )
	Win_PRV.Grid_PRV.Value := {1,nCol}
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_RefreshScreen(aRC)
*------------------------------------------------------------------------------*
	PRV_RefreshData()
	Win_PRV.Grid_PRV.Value := aRC
	Win_PRV.Grid_PRV.Refresh
	Win_PRV.Grid_PRV.Setfocus
RETURN 

*------------------------------------------------------------------------------*
PROCEDURE PRV_RefreshData()
*------------------------------------------------------------------------------*
	PRIV aRC := Win_PRV.Grid_PRV.Value
	
	* msginfo( "Win_PRV.Grid_PRV.Value = " + str(aRC[1]) + ',' + str(aRC[2])  )
	
	IF Win_PRV.Grid_PRV.ItemCount == 0
		PRV_Button_Add()
	ELSE
		IF aRC[1] = 0 .or. aRC[1] > Win_PRV.Grid_PRV.ItemCount		
			PRV_NoAction()
		ELSE
			PRV_Edit()
		ENDIF
	ENDIF	
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_Button_Add()
*------------------------------------------------------------------------------*
	lNew := .T.
	
	Win_PRV.StatusBar.Item(1) := 'Record   ' + Ltrim( Str( Win_PRV.Grid_PRV.ItemCount + 1 ) )
	Win_PRV.StatusBar.Item(2) := 'Toevoegen record'

	Win_PRV.Text_PrvID.Value  := ""
	Win_PRV.Text_PrvNm.Value  := ""
	
	Win_PRV.Text_PrvID.Setfocus 
	Win_PRV.Text_PrvID.ReadOnly := .F.
	Win_PRV.Text_PrvNm.ReadOnly := .F.
	Win_PRV.PRV_Button_Delete.Enabled := .F.
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_Edit()
*------------------------------------------------------------------------------*
	LOCAL aItem
	
	lNew := .F.
	
	aItem := Win_PRV.Grid_PRV.Item(aRC[1])
	
	Win_PRV.StatusBar.Item(1) := 'Record   ' + Ltrim( Str( aRC[1] ) ) + ;
									   ' / ' + Ltrim( Str( Win_PRV.Grid_PRV.ItemCount ) )  
	Win_PRV.StatusBar.Item(2) := 'Onderhoud record'
				
	Win_PRV.Text_PrvID.Value  := aItem[PRVID]
	Win_PRV.Text_PrvNm.Value  := aItem[PRVNM]
	
	Win_PRV.Text_PrvID.ReadOnly := .T.
	Win_PRV.Text_PrvNm.ReadOnly := .F.
	Win_PRV.PRV_Button_Delete.Enabled := .T.
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_NoAction()
*------------------------------------------------------------------------------*
	lNew := .F.
	
	Win_PRV.StatusBar.Item(1) := ''
	Win_PRV.StatusBar.Item(2) := 'Onbepaalde actie'

	Win_PRV.Text_PrvID.Value  := ""
	Win_PRV.Text_PrvNm.Value  := ""
	
	Win_PRV.Text_PrvID.ReadOnly := .T.
	Win_PRV.Text_PrvNm.ReadOnly := .T.
	Win_PRV.PRV_Button_Delete.Enabled := .F.
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_OnEnter_Text_PrvID()
*------------------------------------------------------------------------------*
	Win_PRV.Text_PrvNm.Setfocus
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_OnEnter_Text_PrvNm()
*------------------------------------------------------------------------------*
	PRV_Button_Save()
RETURN

*------------------------------------------------------------------------------*
FUNCTION PRV_Button_Save()
*------------------------------------------------------------------------------*
	LOCAL cPrvID := PADR( Win_PRV.Text_PrvID.Value , LEN(PRV->PrvID) )
	LOCAL aItem  	
	PRIV  aRC    := Win_PRV.Grid_PRV.Value
	
	IF lNew == .T.
		IF EMPTY(cPrvID) 
			MsgSTOP("Empty code" , "Controle")
			Win_PRV.Text_PrvID.Setfocus
			RETURN Nil
		ENDIF
		
		PRV->(DBSetorder('PRVL01'))
		IF PRV->(DBSeek( "BE " + cPrvID ))
			MsgSTOP("Code " + cPrvID + " already exists" , "Controle")
			Win_PRV.Text_PrvID.Setfocus
			RETURN Nil
		ENDIF
	ENDIF

	IF EMPTY( Win_PRV.Text_PrvNm.Value )
		MsgSTOP("Empty name" , "Controle")
		Win_PRV.Text_PrvNm.Setfocus
		RETURN Nil
	ENDIF

	IF lNew == .T.
		PRV->(DBAppend())
		PRV->(RLock())
		PRV->LndID := "BE "
		PRV->PrvID := Win_PRV.Text_PrvID.Value
		PRV_UpdDb()
	ELSE
		aItem := Win_PRV.Grid_PRV.Item(aRC[1])		
		IF PRV->(DBSeek( aItem[LNDID] + aItem[PRVID] ))
			IF PRV->(RecLocked(Alias()))
				PRV_UpdDb()
			ENDIF
		ENDIF
	ENDIF
	
	PRV_RefreshData()
	Win_PRV.Grid_PRV.Setfocus
RETURN Nil

*------------------------------------------------------------------------------*
PROCEDURE PRV_UpdDb()
*------------------------------------------------------------------------------*
	PRV->PrvNm := Win_PRV.Text_PrvNm.Value
	PRV->(DBCommit())
	PRV->(DBUnlock())
	Load_Grid_PRV(PRV->(recno()),aRC[2])
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_Button_Delete()
*------------------------------------------------------------------------------*
	LOCAL aRC   := Win_PRV.Grid_PRV.Value
	LOCAL aItem := Win_PRV.Grid_PRV.Item(aRC[1])
	
	IF PRV->(DBSeek( aItem[LNDID] + aItem[PRVID] ))
		IF MsgOkCancel ("Delete " + aItem[PRVID] + " " + ALLTRIM(aItem[PRVNM]), "Controle")
					
			IF RecLocked('PRV')			
				PRV->(DBDelete())
				PRV->(DBUnlock())
				PRV->(DBSkip())
				IF PRV->(EOF())
					PRV->(DBGobottom())
				ENDIF
				Load_Grid_PRV(PRV->(recno()),aRC[2])		
			ENDIF
			
		ENDIF
	ENDIF
	
	PRV_RefreshData()
	Win_PRV.Grid_PRV.Setfocus
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_Button_Refresh()
*------------------------------------------------------------------------------*
	LOCAL aRC := Win_PRV.Grid_PRV.Value

	Load_Grid_PRV(0,1,.f.)
	PRV_RefreshScreen(aRC)
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_Button_Print()
*------------------------------------------------------------------------------*
	LOCAL lSuccess

	SELECT PRINTER DIALOG TO lSuccess PREVIEW

	If lSuccess == .T.
		PRV_PrintDoc()
	EndIf
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_PrintDoc
*------------------------------------------------------------------------------*
	LOCAL nRecno 
	
	LOCAL cItem2Prnt
	
	PRIV nVertMargin   := 20   // Vertical margin   
	PRIV nHorzMargin   := 20   // Horizontal margin 
	
	PRIV nFontSize     := 10   // In Pixels
	PRIV cFontName     := "Verdana"
	PRIV nCharLength   := 2.25
	PRIV nLineHeigth   := 5
	
	PRIV nMostRightCol := GetPrintableAreaWidth()- nHorzMargin
	PRIV nPageHeigth   := GetPrintableAreaHeight() - (nVertMargin * 2) - (5 * nLineHeigth)   // 1 Top Margin, 1 Bottom Margin, 5 Headerlines
	PRIV nLinesPerPag  := nPageHeigth / nLineHeigth    // Aantal lijnen voor detailafdruk
	PRIV nLinesPrinted 
	PRIV nPageNr       := 0
		
	PRIV nPrintRow 
	PRIV nPrintCol 
	
	START PRINTDOC 
		START PRINTPAGE	
			nRecno := PRV->(recno())
			
			PRV->(DBSetorder( "PRVL01" ))
			PRV->(DBGotop())			

			PRV_PrintPageHeader()

			DO WHILE ! PRV->(EOF())
				nPrintCol := nHorzMargin + 5	

				cItem2Prnt := PRV->LndID
				@ nPrintRow, nPrintCol PRINT cItem2Prnt FONT cFontName SIZE nFontSize  
				nPrintCol += nCharLength * LEN( cItem2Prnt ) + 10

				cItem2Prnt := PRV->PrvID
				@ nPrintRow, nPrintCol PRINT cItem2Prnt FONT cFontName SIZE nFontSize  
				nPrintCol += nCharLength * LEN( cItem2Prnt ) + 10

				cItem2Prnt := PRV->PrvNm
				nPrintCol += nCharLength
				@ nPrintRow, nPrintCol PRINT cItem2Prnt FONT cFontName SIZE nFontSize 

				IF ++nLinesPrinted > nLinesPerPag

					PRV_PrintPageFooter()

					END PRINTPAGE 

					START PRINTPAGE 

					PRV_PrintPageHeader()					
				ELSE
					nPrintRow += nLineHeigth
				ENDIF  						
			
				PRV->(DBSkip())
			ENDDO

			nPrintRow -= nLineHeigth
			PRV_PrintPageFooter()

			PRV->(DBGoto(nRecno))
		END PRINTPAGE
	END PRINTDOC

RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_PrintPageHeader()
*------------------------------------------------------------------------------*
	LOCAL cItem2Prnt, nColumnLen
	
	nPageNr++
	
	nLinesPrinted := 0
	nPrintRow := nVertMargin
	nPrintCol := nHorzMargin 
	
	@ nPrintRow, 105 PRINT "List of provinces" CENTER FONT cFontName SIZE nFontSize BOLD ITALIC
	nPrintRow += nLineHeigth
	@ nPrintRow, nPrintCol PRINT DATE() FONT cFontName SIZE nFontSize
	@ nPrintRow, nMostRightCol PRINT "Page " + NTOC( nPageNr ) RIGHT FONT cFontName SIZE nFontSize
	nPrintRow += nLineHeigth * 2
   
	cItem2Prnt := PRV->LndID   
	nColumnLen := nCharLength * LEN( cItem2Prnt ) - 1 + 10
	@ nPrintRow, nPrintCol + ( nColumnLen / 2 ) PRINT "Country" CENTER BOLD
	@ nPrintRow + nLineHeigth, nPrintCol PRINT LINE TO ;
	  nPrintRow + nLineHeigth, nPrintCol + nColumnLen PENWIDTH .01   
	nPrintCol += nColumnLen + nCharLength
   
	cItem2Prnt := PRV->PrvID   
	nColumnLen := nCharLength * LEN( cItem2Prnt ) - 1 + 10
	@ nPrintRow, nPrintCol + ( nColumnLen / 2 ) PRINT "Province" CENTER BOLD
	@ nPrintRow + nLineHeigth, nPrintCol PRINT LINE TO ;
  	  nPrintRow + nLineHeigth, nPrintCol + nColumnLen PENWIDTH .01   
	nPrintCol += nColumnLen + nCharLength
	
	cItem2Prnt := PRV->PrvNm 
	nColumnLen := nCharLength * LEN( cItem2Prnt ) - 1 + 10
	@ nPrintRow, nPrintCol + ( nColumnLen / 2 ) PRINT "Name" CENTER BOLD
	@ nPrintRow + nLineHeigth, nPrintCol PRINT LINE TO ;
	  nPrintRow + nLineHeigth, nPrintCol + nColumnLen PENWIDTH .01                                 
       	
	nPrintRow += nLineHeigth * 1.5 
RETURN

*------------------------------------------------------------------------------*
PROCEDURE PRV_PrintPageFooter()
*------------------------------------------------------------------------------*
	nPrintRow += nLineHeigth * 1.5
	nPrintCol := nHorzMargin 
	@ nPrintRow, nPrintCol PRINT LINE TO ;
	  nPrintRow, nMostRightCol PENWIDTH .01                                 
RETURN 

*------------------------------------------------------------------------------*
PROCEDURE PRV_Button_Close()
*------------------------------------------------------------------------------*
	ThisWindow.Release
RETURN

*------------------------------------------------------------------------------*
FUNCTION RecLocked( cArea )
*------------------------------------------------------------------------------*
	DO WHILE ! (cArea)->(RLock())
		IF ! MSGRetryCancel("Record lock" , cArea)
			RETURN .F.
		ENDIF
	ENDDO
RETURN .T.
